src/chat/urls.py
from django.urls import path
from .views import Room

app_name = "chat"

urlpatterns = [
    path('chatroom/', Room.as_view(), name='room'),
]

src/jewelry_shop/urls.py
from django.urls import path

from jewelry_shop.views import About, Shop, Contact

from jewelry_shop.views import CategoryView

from jewelry_shop.views import ProductDetails

from jewelry_shop.views import Index

app_name = "jewelry"


urlpatterns = [
    path("", Index.as_view(), name="index"),
    path("about/", About.as_view(), name="about"),
    path("shop/", Shop.as_view(), name="shop"),
    path("contact/", Contact.as_view(), name="contact"),
    path("shop/category/<int:pk>", CategoryView.as_view(), name="category"),
    path("product/<uuid:uuid>", ProductDetails.as_view(), name="details"),
]

src/jewelry_shop/models.py
from django.utils.translation import ugettext as _
from phonenumber_field.modelfields import PhoneNumberField
from django.db import models

from jewelry_shop.services.utils import generate_uuid


class BaseModel(models.Model):
    class Meta:
        abstract = True

    create_date = models.DateTimeField(null=True, auto_now_add=True)
    last_update = models.DateTimeField(null=True, auto_now=True)


class BonusCard(BaseModel):
    uuid = models.UUIDField(default=generate_uuid, db_index=True, unique=True)
    card_name = models.CharField(_("card name"), max_length=150, blank=True)
    min_amount = models.IntegerField(null=False)
    discount = models.IntegerField(null=False)

    def __str__(self):
        return f"{self.card_name}"


class Category(BaseModel):
    category_name = models.CharField(_("category name"), max_length=150, blank=True)
    image = models.ImageField(upload_to='images/', null=False, blank=True)

    def __str__(self):
        return f"{self.category_name}"


class Product(BaseModel):
    uuid = models.UUIDField(default=generate_uuid, db_index=True, unique=True)
    class METAL_CHOICES(models.IntegerChoices):  # noqa:
        INDEFINED = 0, "indefined"
        SILVER = 1, "Silver"
        GOLD = 2, "Gold"

    prod_name = models.CharField(_("prod name"), max_length=150, blank=True)
    category = models.ForeignKey("jewelry_shop.Category", null=True, on_delete=models.CASCADE)
    material = models.PositiveSmallIntegerField(choices=METAL_CHOICES.choices, default=METAL_CHOICES.INDEFINED)
    fineness = models.IntegerField(null=True, blank=True)
    weight = models.FloatField(null=True, blank=True)
    diameter = models.FloatField(null=True, blank=True)
    description = models.CharField(_("description"), max_length=1024, blank=True)
    price = models.IntegerField(null=True)
    balance = models.IntegerField(null=True, blank=True)
    main_image = models.ImageField(upload_to='images/', null=False, blank=True)

    def __str__(self):
        return f"{self.prod_name}"


class ProductMedia(BaseModel):
    product = models.ForeignKey("jewelry_shop.Product", related_name='product_images',
                                on_delete=models.CASCADE, null=True)
    media_link = models.ImageField(upload_to='images/', null=False, blank=False)


class Order(BaseModel):
    class STATUS_CHOICES(models.IntegerChoices):  # noqa:
        NEW = 0, "New"
        PROCESSED = 1, "Processed"
        PAID = 2, "Paid"
        SENT = 3, "Sent"

    status = models.PositiveSmallIntegerField(choices=STATUS_CHOICES.choices, default=STATUS_CHOICES.NEW)
    uuid = models.UUIDField(default=generate_uuid, db_index=True, unique=True)

    class PAYMENT_CHOICES(models.IntegerChoices):  # noqa:
        ON_DELIVERY = 0, "Payment on delivery"
        BY_REQUISITES = 1, "By requisites"
        VISA_MASTERCARD = 2, "Visa/Mastercard"

    payment = models.PositiveSmallIntegerField(choices=PAYMENT_CHOICES.choices, default=PAYMENT_CHOICES.BY_REQUISITES)

    user = models.ForeignKey("accounts.CustomUser", null=False, on_delete=models.CASCADE)
    amount = models.FloatField(null=False)

    address = models.CharField(_("address"), max_length=150, blank=False)
    email = models.EmailField(_("email address"), unique=True)
    first_name = models.CharField(_("first name"), max_length=150, blank=True)
    last_name = models.CharField(_("last name"), max_length=150, blank=True)
    phone_number = PhoneNumberField(unique=True, null=True)

    def __str__(self):
        return f"{self.id} {self.status}"


class OrderContent(models.Model):
    order = models.ForeignKey("jewelry_shop.order", null=False, on_delete=models.CASCADE)
    product = models.ForeignKey("jewelry_shop.product", null=False, on_delete=models.CASCADE)
    count = models.IntegerField(null=False, default=1)

    def __str__(self):
        return f"{self.product}"

src/jewelry_shop/views.py
from django.views.generic import TemplateView, ListView, DetailView

from jewelry_shop.models import Product, Category


class Index(TemplateView):
    template_name = 'index.html'
    extra_context = {'categories': Category.objects.all()}


class About(TemplateView):
    template_name = 'about.html'
    extra_context = {'categories': Category.objects.all()}


class Shop(ListView):
    model = Product
    template_name = 'shop.html'
    extra_context = {'categories': Category.objects.all()}


class Contact(TemplateView):
    template_name = 'contact.html'
    extra_context = {'categories': Category.objects.all()}


class CategoryView(ListView):

    model = Product
    template_name = 'shop.html'
    extra_context = {'categories': Category.objects.all()}

    def get_queryset(self):
        category = self.kwargs.get('pk')
        object_list = Product.objects.all().filter(category=category)
        return object_list


class ProductDetails(DetailView):
    model = Product
    template_name = 'shop-single.html'
    extra_context = {'categories': Category.objects.all()}

    def get_object(self, queryset=None):
        obj = Product.objects.get(uuid=self.kwargs.get("uuid"))
        self.extra_context['product'] = obj
        self.extra_context['images'] = obj.product_images.all()

        return obj

src/jewelry_shop/templates/about.html
{% extends 'index.html' %}
{% block content %}

    <div class="modal fade bg-white" id="templatemo_search" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
            <div class="w-100 pt-1 mb-5 text-right">
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <form action="" method="get" class="modal-content modal-body border-0 p-0">
                <div class="input-group mb-2">
                    <input type="text" class="form-control" id="inputModalSearch" name="q" placeholder="Search ...">
                    <button type="submit" class="input-group-text bg-success text-light">
                        <i class="fa fa-fw fa-search text-white"></i>
                    </button>
                </div>
            </form>
        </div>
    </div>

    <section class="bg-success py-5">
        <div class="container">
            <div class="row align-items-center py-5">
                <div class="col-md-8 text-white">
                    <h1>About Us</h1>

                </div>
                <div class="col-md-4">

                </div>
            </div>
        </div>
    </section>
    <!-- Close Banner -->


{% endblock %}

src/jewelry_shop/templates/contact.html
{% extends 'index.html' %}
{% block content %}

    <div class="container-fluid bg-light py-5">
        <div class="col-md-6 m-auto text-center">
            <h1 class="h1">Contact Us</h1>
            <p>

            </p>
        </div>
    </div>

    <div class="container py-5">
        <div class="row py-5">
            <form class="col-md-9 m-auto" method="post" role="form">
                <div class="row">
                    <div class="form-group col-md-6 mb-3">
                        <label for="inputname">Name</label>
                        <input type="text" class="form-control mt-1" id="name" name="name" placeholder="Name">
                    </div>
                    <div class="form-group col-md-6 mb-3">
                        <label for="inputemail">Email</label>
                        <input type="email" class="form-control mt-1" id="email" name="email" placeholder="Email">
                    </div>
                </div>
                <div class="mb-3">
                    <label for="inputsubject">Subject</label>
                    <input type="text" class="form-control mt-1" id="subject" name="subject" placeholder="Subject">
                </div>
                <div class="mb-3">
                    <label for="inputmessage">Message</label>
                    <textarea class="form-control mt-1" id="message" name="message" placeholder="Message" rows="8"></textarea>
                </div>
                <div class="row">
                    <div class="col text-end mt-2">
                        <button type="submit" class="btn btn-success btn-lg px-3">Let’s Talk</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
{% endblock %}

src/jewelry_shop/templates/profile.html
{% extends "index.html" %}
{% load crispy_forms_tags %}


{% block content %}
<div class="container py-5">
<form method="post" enctype= multipart/form-data>
    {% csrf_token %}
    {{ form|crispy }}
    <br>
    <input class="btn btn-success" type="submit" value="Update"/>
</form>
    </div>

{% endblock %}

src/jewelry_shop/templates/shop-single.html
{% extends 'index.html' %}
{% block content %}
    <!-- Modal -->
    <div class="modal fade bg-white" id="templatemo_search" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
            <div class="w-100 pt-1 mb-5 text-right">
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <form action="" method="get" class="modal-content modal-body border-0 p-0">
                <div class="input-group mb-2">
                    <input type="text" class="form-control" id="inputModalSearch" name="q" placeholder="Search ...">
                    <button type="submit" class="input-group-text bg-success text-light">
                        <i class="fa fa-fw fa-search text-white"></i>
                    </button>
                </div>
            </form>
        </div>
    </div>
    <!-- Open Content -->
    <section class="bg-light">
        <div class="container pb-5">
            <div class="row">
                <div class="col-lg-5 mt-5">
                    <div class="card mb-3">
                        {% if product.main_image %}
                        <img class="card-img img-fluid" src="{{product.main_image.url}}" alt="Card image cap" id="product-detail">
                        {% endif %}
                    </div>
                    <div class="row">
                        <!--Start Controls-->
                        <div class="col-1 align-self-center">
                            <a href="#multi-item-example" role="button" data-bs-slide="prev">
                                <i class="text-dark fas fa-chevron-left"></i>
                                <span class="sr-only">Previous</span>
                            </a>
                        </div>
                        <!--End Controls-->
                        <!--Start Carousel Wrapper-->
                        <div id="multi-item-example" class="col-10 carousel slide carousel-multi-item" data-bs-ride="carousel">
                            <!--Start Slides-->
                            <div class="carousel-inner product-links-wap" role="listbox">

                                <!--First slide-->
                                <div class="carousel-item active">
                                    <div class="row">
                                        {% for image in images %}
                                        <div class="col-4">
                                            <a href="#multi-item-example" role="button" data-bs-slide="prev">
                                                <img class="card-img img-fluid" src="{{image.media_link.url}}" alt="Product Image">
                                            </a>
                                        </div>
                                        {% endfor %}
                                    </div>
                                </div>
                                <!--/.First slide-->

                            </div>
                            <!--End Slides-->
                        </div>
                        <!--End Carousel Wrapper-->
                        <!--Start Controls-->
                        <div class="col-1 align-self-center">
                            <a href="#multi-item-example" role="button" data-bs-slide="next">
                                <i class="text-dark fas fa-chevron-right"></i>
                                <span class="sr-only">Next</span>
                            </a>
                        </div>
                        <!--End Controls-->
                    </div>
                </div>
                <!-- col end -->
                <div class="col-lg-7 mt-5">
                    <div class="card">
                        <div class="card-body">
                            <h1 class="h2">{{product.prod_name}}</h1>
                            <p class="h3 py-2">{{product.price}} UAH</p>
                                <ul class="list-inline">
                                <li class="list-inline-item">
                                    <h6>Material:</h6>
                                </li>
                                <li class="list-inline-item">
                                    <p class="text-muted"><strong>{{ product.get_material_display }}</strong></p>
                                </li>
                            </ul>
                            <ul class="list-inline">
                                <li class="list-inline-item">
                                    <h6>Fineness:</h6>
                                </li>
                                <li class="list-inline-item">
                                    <p class="text-muted"><strong>{{product.fineness}}</strong></p>
                                </li>
                            </ul>
                             <ul class="list-inline">
                                <li class="list-inline-item">
                                    <h6>Weight:</h6>
                                </li>
                                <li class="list-inline-item">
                                    <p class="text-muted"><strong>{{product.weight}} g</strong></p>
                                </li>
                            </ul>
                               <ul class="list-inline">
                                <li class="list-inline-item">
                                    <h6>Diameter:</h6>
                                </li>
                                <li class="list-inline-item">
                                    <p class="text-muted"><strong>{{product.diameter}} mm</strong></p>
                                </li>
                            </ul>
                                  <ul class="list-inline">
                                <li class="list-inline-item">
                                    <h6>Description:</h6>
                                </li>
                                <li class="list-inline-item">
                                    <p class="text-muted"><strong>{{product.description}}</strong></p>
                                </li>
                            </ul>

                            <form action="" method="GET">
                                <input type="hidden" name="product-title" value="Activewear">
                                <div class="row">

                                    <div class="col-auto">
                                        <ul class="list-inline pb-3">
                                            <li class="list-inline-item text-right">
                                                Quantity
                                                <input type="hidden" name="product-quanity" id="product-quanity" value="1">
                                            </li>
                                            <li class="list-inline-item"><span class="btn btn-success" id="btn-minus">-</span></li>
                                            <li class="list-inline-item"><span class="badge bg-secondary" id="var-value">1</span></li>
                                            <li class="list-inline-item"><span class="btn btn-success" id="btn-plus">+</span></li>
                                        </ul>
                                    </div>
                                </div>
                                <div class="row pb-3">
                                    <div class="col d-grid">
                                        <button type="submit" class="btn btn-success btn-lg" name="submit" value="buy">Buy</button>
                                    </div>
                                    <div class="col d-grid">
                                        <button type="submit" class="btn btn-success btn-lg" name="submit" value="addtocard">Add To Cart</button>
                                    </div>
                                </div>
                            </form>

                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <!-- Close Content -->

{% endblock %}

src/jewelry_shop/templates/shop.html
{% extends 'index.html' %}
{% load static %}
{% block content %}

    <div class="modal fade bg-white" id="templatemo_search" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
            <div class="w-100 pt-1 mb-5 text-right">
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <form action="" method="get" class="modal-content modal-body border-0 p-0">
                <div class="input-group mb-2">
                    <input type="text" class="form-control" id="inputModalSearch" name="q" placeholder="Search ...">
                    <button type="submit" class="input-group-text bg-success text-light">
                        <i class="fa fa-fw fa-search text-white"></i>
                    </button>
                </div>
            </form>
        </div>
    </div>

    <!-- Start Content -->
    <div class="container py-5">
        <div class="row">

            <div class="col-lg-3">
                <h1 class="h2 pb-4">Categories</h1>

                   {% for category in categories %}
                        <a class="collapsed d-flex justify-content-between h3 text-decoration-none" href="{% url 'jewelry:category' category.id %}">
                            {{category.category_name}}
                        </a>
                    {% endfor %}
            </div>

            <div class="col-lg-9">
                <div class="row">
                    {% for product in object_list %}
                    <div class="col-md-4">
                        <div class="card mb-4 product-wap rounded-0">
                            <div class="card rounded-0">
                                {% if product.main_image %}
                                <img class="card-img rounded-0 img-fluid" src="{{product.main_image.url }}">
                                {% endif %}
                                <div class="card-img-overlay rounded-0 product-overlay d-flex align-items-center justify-content-center">
                                    <ul class="list-unstyled">
                                        <li><a class="btn btn-success text-white" href="{% url 'jewelry:details' product.uuid %}"><i class="far fa-heart"></i></a></li>
                                        <li><a class="btn btn-success text-white mt-2" href="{% url 'jewelry:details' product.uuid %}"><i class="far fa-eye"></i></a></li>
                                        <li><a class="btn btn-success text-white mt-2" href="{% url 'jewelry:details' product.uuid %}"><i class="fas fa-cart-plus"></i></a></li>
                                    </ul>
                                </div>
                            </div>
                            <div class="card-body">
                                <a href="{% url 'jewelry:details' product.uuid %}" class="h3 text-decoration-none">{{product.prod_name}}</a>
                                <p class="text-center mb-0">{{product.price}} UAH</p>
                            </div>
                        </div>
                    </div>
                {% endfor %}
                <div div="row">
                    <ul class="pagination pagination-lg justify-content-end">
                        <li class="page-item disabled">
                            <a class="page-link active rounded-0 mr-3 shadow-sm border-top-0 border-left-0" href="#" tabindex="-1">1</a>
                        </li>
                        <li class="page-item">
                            <a class="page-link rounded-0 mr-3 shadow-sm border-top-0 border-left-0 text-dark" href="#">2</a>
                        </li>
                        <li class="page-item">
                            <a class="page-link rounded-0 shadow-sm border-top-0 border-left-0 text-dark" href="#">3</a>
                        </li>
                    </ul>
                </div>
            </div>

        </div>
    </div>
    <!-- End Content -->
                        <!--Carousel Wrapper-->
                        <div class="col">
                            <div class="carousel slide carousel-multi-item pt-2 pt-md-0" id="multi-item-example" data-bs-ride="carousel">
                                <!--Slides-->
                                <div class="carousel-inner product-links-wap" role="listbox">
                    </div>
                </div>
            </div>
        </div>
    </section>
{% endblock %}